#include <zombie_escape>
#include <fakemeta_util>
#include <cstrike>
#include <fun>

#define CSW_WEAPON_BASE CSW_P228
#define CSW_NEW_WEAPON "weapon_dvulcanus1"
#define CSW_OLD_WEAPON "weapon_p228"
#define WEAPON_KEY 9595959
#define OLD_WEAPON "models/w_p228.mdl"
#define is_user_valid(%1) (is_user_alive(%1) && !is_user_bot(%1) && !is_user_hltv(%1) && is_user_connected(%1))

enum
{	
	MODE_NONE = 0,
	MODE_A,
	MODE_B
}

new const Weapon_Models[][] = { "models/v_dvulcanus1.mdl", "models/p_dvulcanus1.mdl", "models/w_dvulcanus1.mdl" }
new const Weapon_Sounds[][] = 
{ 
	"weapons/vulcanus1-1.wav", 
	"weapons/vulcanus1_draw.wav", 
	"weapons/vulcanus1_drawb.wav", 
	"weapons/vulcanus1_reload.wav", 
	"weapons/vulcanus1_clipin1.wav", 
	"weapons/vulcanus1_clipout.wav",
	"weapons/vulcanus_cap2.wav",
	"weapons/vulcanus_cip1.wav",
	"weapons/vulcanus1_changea.wav",
	"weapons/vulcanus1_changeb.wav"
}
new const Weapon_Sprites[][] = { "sprites/weapon_dvulcanus1.txt", "sprites/dvulcanus1_had.spr", "sprites/dvulcanus1_hud.spr" }
new const GUNSHOT_DECALS[] = { 41, 42, 43, 44, 45 }

new DVulc1, bool:g_HasDVulc1[33], Mode[33]
new Cvar_DVulc1_Recoil, Cvar_DVulc1_DMG, Cvar_DVulc1_Clip, Cvar_DVulc1_Ammo
new Float:cl_pushangle[33][3], g_EventDVulc1, g_DVulc1_TmpClip[33], g_IsInPrimaryAttack

public plugin_precache()
{
	for(new g = 0; g < sizeof(Weapon_Models); g++)
		precache_model(Weapon_Models[g])
	for(new h = 0; h < sizeof(Weapon_Sounds); h++)
		precache_sound(Weapon_Sounds[h])
	for(new t = 0; t < sizeof(Weapon_Sprites); t++)
		precache_generic(Weapon_Sprites[t])
		
	register_clcmd(CSW_NEW_WEAPON, "hook")
	register_forward(FM_PrecacheEvent, "Fw_Precache_Event", 1)
}

public hook(id)
{
	engclient_cmd(id, CSW_OLD_WEAPON)
	return PLUGIN_HANDLED
}

public plugin_init()
{
	register_plugin("[ZP] Extra Item: Vulcanus-1", "1.0", "JaCk GamePlay")
	DVulc1 = ze_register_item("Vulcanus-1", 1, 0)
	
	// Events & Messages
	register_message(get_user_msgid("DeathMsg"), "DeathMsg")
	register_message(get_user_msgid("CurWeapon"), "CurWeapon")
	register_event("CurWeapon", "CurrentWeapon", "be", "1=1")
	register_event("HLTV", "New_Round", "a", "1=0", "2=0")
	
	// Forwards
	register_forward(FM_SetModel, "Fw_Set_Model", 1)
	register_forward(FM_PlaybackEvent, "Fw_Playback_Event")
	register_forward(FM_UpdateClientData, "Fw_Update_Clientdata", 1)
	register_forward(FM_CmdStart, "Fw_CmdStart", 1)
	
	// Hams
	RegisterHam(Ham_Weapon_PrimaryAttack, CSW_OLD_WEAPON, "Fw_PrimaryAttack")
	RegisterHam(Ham_Weapon_PrimaryAttack, CSW_OLD_WEAPON, "Fw_PrimaryAttack_Post", 1)
	RegisterHam(Ham_TakeDamage, "player", "Fw_Take_DMG")
	RegisterHam(Ham_Item_AddToPlayer, CSW_OLD_WEAPON, "Fw_AddToPlayer")
	RegisterHam(Ham_Weapon_Reload, CSW_OLD_WEAPON, "Fw_Reload")
	RegisterHam(Ham_Weapon_Reload, CSW_OLD_WEAPON, "Fw_Reload_Post", 1)
	RegisterHam(Ham_Spawn, "player", "Fw_Spawn", 1)
	RegisterHam(Ham_TraceAttack, "worldspawn", "Fw_TraceAttack", 1)
	RegisterHam(Ham_TraceAttack, "func_breakable", "Fw_TraceAttack", 1)
	RegisterHam(Ham_TraceAttack, "func_wall", "Fw_TraceAttack", 1)
	RegisterHam(Ham_TraceAttack, "func_door", "Fw_TraceAttack", 1)
	RegisterHam(Ham_TraceAttack, "func_door_rotating", "Fw_TraceAttack", 1)
	RegisterHam(Ham_TraceAttack, "func_plat", "Fw_TraceAttack", 1)
	RegisterHam(Ham_TraceAttack, "func_rotating", "Fw_TraceAttack", 1)
	RegisterHam(Ham_Use, "func_tank", "Fw_UseStationary_Post", 1)
	RegisterHam(Ham_Use, "func_tankmortar", "Fw_UseStationary_Post", 1)
	RegisterHam(Ham_Use, "func_tankrocket", "Fw_UseStationary_Post", 1)
	RegisterHam(Ham_Use, "func_tanklaser", "Fw_UseStationary_Post", 1)
	RegisterHam(Ham_Item_Deploy, CSW_OLD_WEAPON, "Fw_Item_Deploy_Post", 1)
	RegisterHam(Ham_Weapon_WeaponIdle, CSW_OLD_WEAPON, "Fw_Item_WeaponIdle")
	
	// Cvars
	Cvar_DVulc1_Recoil = register_cvar("ze_dvulc1_recoil", "1.0")
	Cvar_DVulc1_DMG = register_cvar("ze_dvulc1_damage", "6")
	Cvar_DVulc1_Clip = register_cvar("ze_dvulc1_clip", "30")
	Cvar_DVulc1_Ammo = register_cvar("ze_dvulc1_ammo", "120")
}

public Fw_Item_WeaponIdle(const iItem, const id)
{
	ExecuteHamB(Ham_Weapon_ResetEmptySound, iItem)

	if (get_pdata_int(iItem, 48, 4) > 0.0)
		return
	
	set_pdata_float(iItem, 48, 10.5, 4)
	set_pdata_int(iItem, 30, (!get_pdata_int(iItem, 30, 4)), 4)
	if(Mode[id] == MODE_A)
	{
		UTIL_weapon_anim(id, iItem, 5)
	}
	else if(Mode[id] == MODE_B)
	{
		UTIL_weapon_anim(id, iItem, 0)
	}
}

public Fw_Item_Deploy_Post(weapon_ent)
{
	new id = get_pdata_cbase(weapon_ent, 41, 4)
	if(Mode[id] == MODE_A)
	{
		UTIL_weapon_anim(id, weapon_ent, 14)
	}
	else if(Mode[id] == MODE_B)
	{
		UTIL_weapon_anim(id, weapon_ent, 2)
	}
	CurrentWeapon(id)
}

public Fw_UseStationary_Post(entity, caller, activator, use_type)
{
	if (use_type == 0 && is_user_valid(caller))
	{
		CurrentWeapon(caller)
	}
}

public Fw_CmdStart(id, handle)
{
	if(!is_user_valid(id) || ze_is_user_zombie(id))	return
	
	if(get_uc(handle, UC_Buttons) & IN_ATTACK2 && !(pev(id, pev_oldbuttons) & IN_ATTACK2))
	{
		if(get_user_weapon(id) == CSW_WEAPON_BASE && g_HasDVulc1[id])
		{
			if(Mode[id] == MODE_A)
			{
				UTIL_weapon_anim(id, id, 16)
				Mode[id] = MODE_B
			}
			else if(Mode[id] == MODE_B)
			{
				UTIL_weapon_anim(id, id, 15)
				Mode[id] = MODE_A
			}
		}
	}
}

public Fw_TraceAttack(iEnt, iAttacker, Float:flDamage, Float:fDir[3], ptr, iDamageType)
{
	if(!is_user_valid(iAttacker))
		return
	
	static Float:flEnd[3]
	get_tr2(ptr, TR_vecEndPos, flEnd)
	
	if(get_user_weapon(iAttacker) == CSW_WEAPON_BASE && g_HasDVulc1[iAttacker])
	{
		if(iEnt)
		{
			message_begin(MSG_BROADCAST, SVC_TEMPENTITY)
			write_byte(TE_DECAL)
			engfunc(EngFunc_WriteCoord, flEnd[0])
			engfunc(EngFunc_WriteCoord, flEnd[1])
			engfunc(EngFunc_WriteCoord, flEnd[2])
			write_byte(GUNSHOT_DECALS[random_num (0, sizeof GUNSHOT_DECALS -1)])
			write_short(iEnt)
			message_end()
		}
		else
		{
			message_begin(MSG_BROADCAST, SVC_TEMPENTITY)
			write_byte(TE_WORLDDECAL)
			engfunc(EngFunc_WriteCoord, flEnd[0])
			engfunc(EngFunc_WriteCoord, flEnd[1])
			engfunc(EngFunc_WriteCoord, flEnd[2])
			write_byte(GUNSHOT_DECALS[random_num (0, sizeof GUNSHOT_DECALS -1)])
			message_end()
		}
		message_begin(MSG_BROADCAST, SVC_TEMPENTITY)
		write_byte(TE_GUNSHOTDECAL)
		engfunc(EngFunc_WriteCoord, flEnd[0])
		engfunc(EngFunc_WriteCoord, flEnd[1])
		engfunc(EngFunc_WriteCoord, flEnd[2])
		write_short(iAttacker)
		write_byte(GUNSHOT_DECALS[random_num (0, sizeof GUNSHOT_DECALS -1)])
		message_end()
	}
}

public Fw_Spawn(id)
{
	if(!is_user_valid(id))
		return
		
	Remove_DVulc1(id)
}

public New_Round()
{
	for(new i = 0; i < get_maxplayers(); i++)
	{
		if(!is_user_valid(i) || !g_HasDVulc1[i])
			continue
			
		Remove_DVulc1(i)
	}
}

public Fw_Reload_Post(weapon_entity) 
{
	new id = pev(weapon_entity, pev_owner)
	if (!is_user_valid(id) || ze_is_user_zombie(id) || g_DVulc1_TmpClip[id] == -1)
		return HAM_IGNORED
		
	if(g_HasDVulc1[id])
	{
		set_pdata_int(weapon_entity, 51, g_DVulc1_TmpClip[id], 4)
		set_pdata_float(weapon_entity, 48, 3.0, 4)
		set_pdata_float(id, 83, 3.0, 5)
		set_pdata_int(weapon_entity, 54, 1, 4)
		if(Mode[id] == MODE_A)
		{
			UTIL_weapon_anim(id, weapon_entity, 13)
		}
		else if(Mode[id] == MODE_B)
		{
			UTIL_weapon_anim(id, weapon_entity, 1)
		}
		set_task(3.0, "Update_Ammo", weapon_entity)
	}
	return HAM_IGNORED
}

public Update_Ammo(weapon)
{
	if(!pev_valid(weapon))	return
	
	cs_set_weapon_ammo(weapon, get_pcvar_num(Cvar_DVulc1_Clip))
}

public Fw_Reload(weapon_entity) 
{
	new id = pev(weapon_entity, pev_owner)
	if (!is_user_valid(id) || ze_is_user_zombie(id))
		return HAM_IGNORED

	static iClipExtra
	if(g_HasDVulc1[id])
	{
		iClipExtra = get_pcvar_num(Cvar_DVulc1_Clip)
	}

	g_DVulc1_TmpClip[id] = -1
	
	new iBpAmmo = cs_get_user_bpammo(id, CSW_WEAPON_BASE)
	new iClip = get_pdata_int(weapon_entity, 51, 4)

	if (iBpAmmo <= 0 || iClip >= iClipExtra)
		return HAM_SUPERCEDE

	g_DVulc1_TmpClip[id] = iClip

	return HAM_IGNORED
}

public Fw_AddToPlayer(DVulc1, id)
{
	if(!is_valid_ent(DVulc1) || !is_user_valid(id) || ze_is_user_zombie(id))
		return HAM_IGNORED
	
	if(entity_get_int(DVulc1, EV_INT_impulse) == WEAPON_KEY)
	{
		g_HasDVulc1[id] = true
		Mode[id] = MODE_A
		entity_set_int(DVulc1, EV_INT_impulse, 0)
		
		message_begin(MSG_ONE, get_user_msgid("WeaponList"), {0, 0, 0}, id)
		write_string(CSW_NEW_WEAPON)
		write_byte(9)
		write_byte(52)
		write_byte(-1)
		write_byte(-1)
		write_byte(1)
		write_byte(3)
		write_byte(CSW_WEAPON_BASE)
		write_byte(0)
		message_end()
		return HAM_HANDLED
	}
	else
	{
		message_begin(MSG_ONE, get_user_msgid("WeaponList"), {0, 0, 0}, id)
		write_string(CSW_OLD_WEAPON)
		write_byte(9)
		write_byte(52)
		write_byte(-1)
		write_byte(-1)
		write_byte(1)
		write_byte(3)
		write_byte(CSW_WEAPON_BASE)
		write_byte(0)
		message_end()
	}
	return HAM_IGNORED
}

public Fw_Precache_Event(type, const name[])
{
	if(equal("events/p228.sc", name))
	{
		g_EventDVulc1 = get_orig_retval()
	}
}

public Fw_Update_Clientdata(id, sendweapons, cd_handle)
{
	if(!is_user_valid(id))
		return

	if(get_user_weapon(id) == CSW_WEAPON_BASE && g_HasDVulc1[id])
	{
		set_cd(cd_handle, CD_flNextAttack, halflife_time() + 0.001)
	}
}

public Fw_Playback_Event(flags, invoker, eventid, Float:delay, Float:origin[3], Float:angles[3], Float:fparam1, Float:fparam2, iParam1, iParam2, bParam1, bParam2)
{
	if(!is_user_valid(invoker) || !g_IsInPrimaryAttack)
		return
    
	if(eventid == g_EventDVulc1 && get_user_weapon(invoker) == CSW_WEAPON_BASE && g_HasDVulc1[invoker])
	{
		engfunc(EngFunc_PlaybackEvent, flags | FEV_HOSTONLY, invoker, eventid, delay, origin, angles, fparam1, fparam2, iParam1, iParam2, bParam1, bParam2)
		if(Mode[invoker] == MODE_A)
		{
			UTIL_weapon_anim(invoker, eventid, random_num(random_num(7, 8), random_num(10, 11)))
		}
		else if(Mode[invoker] == MODE_B)
		{
			UTIL_weapon_anim(invoker, eventid, 3)
		}
		emit_sound(invoker, CHAN_WEAPON, Weapon_Sounds[0], 1.0, ATTN_NORM, 0, PITCH_NORM)
	}
}

public ze_user_humanized(id)
{
	if(!is_user_valid(id))
		return
		
	Remove_DVulc1(id)
}

public ze_user_infected(id, infector)
{
	if(!is_user_valid(id) || !is_user_valid(infector))
		return
		
	Remove_DVulc1(id)
}

public Fw_PrimaryAttack(Weapon)
{
	g_IsInPrimaryAttack = 0
	
	new szClip, szAmmo, id
	id = get_pdata_cbase(Weapon, 41, 4)
	get_user_weapon(id, szClip, szAmmo)
	if(!is_user_valid(id) || ze_is_user_zombie(id))
		return

	g_IsInPrimaryAttack = 1
	if(g_HasDVulc1[id])
	{
		if (!cs_get_weapon_ammo(Weapon))
			return

		new Float:push[3]
		pev(id, pev_punchangle, push)
		xs_vec_sub(push, cl_pushangle[id], push)
		xs_vec_mul_scalar(push, get_pcvar_float(Cvar_DVulc1_Recoil), push)
		xs_vec_add(push, cl_pushangle[id], push)
		set_pev(id, pev_punchangle, push)
		emit_sound(id, CHAN_WEAPON, Weapon_Sounds[0], VOL_NORM, ATTN_NORM, 0, PITCH_NORM)
		if(Mode[id] == MODE_A)
		{
			UTIL_weapon_anim(id, Weapon, random_num(random_num(7, 8), random_num(10, 11)))
		}
		else if(Mode[id] == MODE_B)
		{
			UTIL_weapon_anim(id, Weapon, 3)
		}
	}
}

public Fw_Take_DMG(Victim, Inflictor, Attacker, Float:Damage, DamageType)
{
	if(!is_user_valid(Victim) || !is_user_valid(Attacker) || ze_is_user_zombie(Attacker))
		return
	
	if(get_user_weapon(Attacker) == CSW_WEAPON_BASE && g_HasDVulc1[Attacker])
	{
		SetHamParamFloat(4, Damage * get_pcvar_float(Cvar_DVulc1_DMG))
	}
}

public Fw_PrimaryAttack_Post(Weapon)
{
	g_IsInPrimaryAttack = 0
	new szClip, szAmmo, id
	id = get_pdata_cbase(Weapon, 41, 4)
	get_user_weapon(id, szClip, szAmmo)
	
	if(!is_user_valid(id) || ze_is_user_zombie(id))
		return

	if(g_HasDVulc1[id])
	{
		if (!cs_get_weapon_ammo(Weapon))
			return

		new Float:push[3]
		pev(id, pev_punchangle, push)
		xs_vec_sub(push, cl_pushangle[id], push)
		xs_vec_mul_scalar(push, get_pcvar_float(Cvar_DVulc1_Recoil), push)
		xs_vec_add(push, cl_pushangle[id], push)
		set_pev(id, pev_punchangle, push)
		emit_sound(id, CHAN_WEAPON, Weapon_Sounds[0], VOL_NORM, ATTN_NORM, 0, PITCH_NORM)
		if(Mode[id] == MODE_A)
		{
			UTIL_weapon_anim(id, Weapon, random_num(random_num(7, 8), random_num(10, 11)))
		}
		else if(Mode[id] == MODE_B)
		{
			UTIL_weapon_anim(id, Weapon, 3)
		}
	}
}

public Fw_Set_Model(entity, model[])
{
	if(!pev_valid(entity) || !equal(model, OLD_WEAPON))
		return FMRES_IGNORED
	
	static szClassName[33], id
	id = pev(entity, pev_owner)
	pev(entity, pev_classname, szClassName, charsmax(szClassName))
	if(!equal(szClassName, "weaponbox"))
		return FMRES_IGNORED
	
	if(g_HasDVulc1[id] && pev_valid(fm_find_ent_by_owner(-1, CSW_OLD_WEAPON, entity)))
	{
		g_HasDVulc1[id] = false
		Mode[id] = MODE_NONE
		set_pev(fm_find_ent_by_owner(-1, CSW_OLD_WEAPON, entity), pev_impulse, WEAPON_KEY)
		engfunc(EngFunc_SetModel, entity, Weapon_Models[2])
		return FMRES_SUPERCEDE
	}
	return FMRES_IGNORED
}

public CurrentWeapon(id)
{
	if(!is_user_valid(id))
		return
		
	if(get_user_weapon(id) == CSW_WEAPON_BASE && g_HasDVulc1[id])
	{
		cs_set_player_view_model(id, CSW_WEAPON_BASE, Weapon_Models[0])
		cs_set_player_weap_model(id, CSW_WEAPON_BASE, Weapon_Models[1])
		
		message_begin(MSG_ONE_UNRELIABLE, get_user_msgid("CurWeapon"), _, id)
		write_byte(1)
		write_byte(CSW_WEAPON_BASE)
		write_byte(cs_get_weapon_ammo(rg_find_weapon_bpack_by_name(id, CSW_OLD_WEAPON)))
		message_end()
		
		message_begin(MSG_ONE, get_user_msgid("WeaponList"), {0, 0, 0}, id)
		write_string(CSW_NEW_WEAPON)
		write_byte(9)
		write_byte(52)
		write_byte(-1)
		write_byte(-1)
		write_byte(1)
		write_byte(3)
		write_byte(CSW_WEAPON_BASE)
		write_byte(0)
		message_end()
	}
}

public DeathMsg(msg_id, msg_dest, id)
{
	static szTruncatedWeapon[33], iAttacker, iVictim
	get_msg_arg_string(4, szTruncatedWeapon, charsmax(szTruncatedWeapon))
	
	iAttacker = get_msg_arg_int(1)
	iVictim = get_msg_arg_int(2)
	
	if(!is_user_valid(iAttacker) || iAttacker == iVictim)
		return
	
	if(equal(szTruncatedWeapon, "p228") && get_user_weapon(iAttacker) == CSW_WEAPON_BASE && g_HasDVulc1[iAttacker])
	{
		set_msg_arg_string(4, "vulcanus-1")
	}
}

public CurWeapon(msgid, msg_dest, id)
{
	if(!is_user_alive(get_msg_arg_int(2)))	return
	
	if(get_user_weapon(get_msg_arg_int(2)) == CSW_WEAPON_BASE && g_HasDVulc1[get_msg_arg_int(2)])
	{
		set_msg_arg_int(2, get_msg_arg_int(2), cs_get_weapon_ammo(rg_find_weapon_bpack_by_name(id, CSW_OLD_WEAPON)))
	}
}

public ze_select_item_pre(id, itemid)
{
	if(itemid != DVulc1)	return ZE_ITEM_AVAILABLE
	if(ze_is_user_zombie(id))	return ZE_ITEM_DONT_SHOW
	return ZE_ITEM_AVAILABLE
}

public ze_select_item_post(id, itemid)
{
	if(itemid != DVulc1)	return
		
	GiveDVulc1(id)
}

public GiveDVulc1(id)
{
	drop_weapons(id, 2)
	give_item(id, CSW_OLD_WEAPON)
	set_member(rg_find_weapon_bpack_by_name(id, CSW_OLD_WEAPON), m_Weapon_iClip, get_pcvar_num(Cvar_DVulc1_Clip))
	rg_set_user_bpammo(id, WeaponIdType:get_weaponid(CSW_OLD_WEAPON), get_pcvar_num(Cvar_DVulc1_Ammo))
		
	message_begin(MSG_ONE, get_user_msgid("WeaponList"), {0, 0, 0}, id)
	write_string(CSW_NEW_WEAPON)
	write_byte(9)
	write_byte(52)
	write_byte(-1)
	write_byte(-1)
	write_byte(1)
	write_byte(3)
	write_byte(CSW_WEAPON_BASE)
	write_byte(0)
	message_end()

	g_HasDVulc1[id] = true
	Mode[id] = MODE_A
	UTIL_weapon_anim(id, CSW_WEAPON_BASE, 14)
	ze_colored_print(id, "You bought Dual Vulcanus-1.")
}

public Remove_DVulc1(id)
{
	if(!is_user_valid(id))
		return
		
	g_HasDVulc1[id] = false
	Mode[id] = MODE_NONE
	message_begin(MSG_ONE, get_user_msgid("WeaponList"), {0, 0, 0}, id)
	write_string(CSW_OLD_WEAPON)
	write_byte(9)
	write_byte(52)
	write_byte(-1)
	write_byte(-1)
	write_byte(1)
	write_byte(3)
	write_byte(CSW_WEAPON_BASE)
	write_byte(0)
	message_end()
	cs_reset_player_view_model(id, CSW_WEAPON_BASE)
	cs_reset_player_weap_model(id, CSW_WEAPON_BASE)
}

UTIL_weapon_anim(index, entity, sequence = 0)
{
	set_pev(index, pev_weaponanim, sequence)

	message_begin(MSG_ONE_UNRELIABLE, SVC_WEAPONANIM, {0, 0, 0}, index)
	write_byte(sequence)
	write_byte(pev(entity, pev_body))
	message_end()
}

stock drop_weapons(id, dropwhat)
{
	static weapons[32], num, i, weaponid
	num = 0
	get_user_weapons(id, weapons, num)
	
	const SEC_WEAPONS_BITSUM = (1<<CSW_P228)|(1<<CSW_GLOCK18)|(1<<CSW_USP)|(1<<CSW_DEAGLE)|(1<<CSW_ELITE)|(1<<CSW_FIVESEVEN)

	for (i = 0; i < num; i++)
	{
		weaponid = weapons[i]
		
		if (dropwhat == 2 && ((1<<weaponid) & SEC_WEAPONS_BITSUM))
		{
			static wname[32]
			get_weaponname(weaponid, wname, charsmax(wname))
			engclient_cmd(id, "drop", wname)
		}
	}
}